add_library('peasycam')

from meshobjs import Node, Face, Mesh
from rules import *
from primitives import *
from io import *

def setup():
    size(800*2,450*2,P3D)
    cam = PeasyCam(this,500)
    noStroke()
    
    global bgimage
    bgimage = loadImage("galactic_starfield_800x450.jpg")

    global planet1, planet2, planet3, planet4
    rp = RulePyramid()
    rt = RuleTapered()
    
    # Create your crystal here
    
    # b = Dodecahedron(0,0,0,40)
    b = Box(0,0,0,100,100,100)
    planet1 = b.get_mesh()
    
    #planet1 = rp.replace(planet1, 50)
    planet1 = rt.replace(planet1, 0.0, 100, False)
    planet1 = rt.replace(planet1, 0.5, 10, False)
    
    #planet1 = rp.replace(planet1, 10)
    #planet1 = rp.replace(planet1, -20)
    #planet1 = rp.replace(planet1, 20)
    #planet1 = rp.replace(planet1, -10)
    #planet1 = rp.replace(planet1, 20)
    
    #for i in range(2):
        #planet1 = rp.replace(planet1, 10)
        #planet1 = rt.replace(planet1, 0.5, 10, True)

    export_obj(planet1,"obj_exports/sun.obj")
    
    
def draw():
    background(255, 255, 255)
    rotateX(PI/3)
    
    # directional lights
    directionalLight(  255,  0, 127,   0.0,  0.0, -1.0)
    directionalLight(  0,  127, 255,  -1.0,  0.0,  0.3)
    directionalLight(  127,255,   0,   0.5,  1.0,  0.3)
    directionalLight(  0,  255, 127,   0.5, -1.0,  0.3)
    
    # point lights
    pushMatrix()
    # to p2
    rotateZ(frameCount/100.0)
    translate(200,0,0)
    # blue light
    pointLight(0,127,255,0,0,0)
    # to its moon
    rotateZ(-frameCount/50.0)
    translate(100,0,0)
    # pink light
    pointLight(255,0,127,0,0,0)
    popMatrix()
    pushMatrix()
    # to p3
    rotateZ(-frameCount/60.0)
    translate(350,0,0)
    # green light
    pointLight(0,255,127,0,0,0)
    popMatrix()

    
    # display the sun (p1)
    pushMatrix()
    rotateZ(-frameCount/200.0)
    for f in planet1.faces:
        beginShape()
        for n in f.nodes:
            vertex(n.x,n.y,n.z)
        endShape(CLOSE)
    popMatrix()

    
